	section getchan
	XDEF	chan_num
	xdef	chan_num2
***********************************************************
*
* this gets the channel ID corresponding to the channel number passed as the
* first parameter pointed to by A3
* it defaults to 1 if no valid channel number passed. The channel number
* MUST be preceded by '#'
* on exit:
* A0 = channel ID (for chan_num)
* A4 = channel ID (for chan_num2), A0 corrupted
*
* all other regs affected as per vector $112
* D0 = error or 0
* error flag set
***********************************************************

chan_num2 BSR.S chan_num
	BNE.S	get_out
	MOVE.L	A0,A4
	RTS
chan_num MOVEQ	 #1,D0		 ; preset canal#1
	MOVE.B	1(A6,A3.L),D1	; On vrifie si le premier sparateur
	ANDI.B	#128,D1 	; tait '#', alors un canal a t don-
	BEQ.S	getchan 	; n, sinon on suppose canal #1
	MOVEM.L D5/A2,-(A7)
	MOVE.L	A5,D5		; sauvegarde du pointeur
	MOVE.L	A3,A5
	ADDQ.L	#8,A5		; A5= A3 + 8, donc on recherche 1 param
	MOVE.W	$112,A2 	; Vecteur $112, place un param. entier sur
	JSR	(A2)		; la pile pointe par 0(A6,A1.L)
	ADD.L	#2,$58(A6)	; reset maths stck pointer
	ADDQ.L	#8,A3		; On limine le param qu'on a cherch
	MOVE.L	D5,A5		; retour du pointeur
	MOVEM.L (A7)+,D5/A2
	TST.W	D0
	BNE.S	get_out 	; Si erreur, D0 contient code erreur
	MOVE.W	0(A6,A1.L),D0	; D0=param
	BMI.S	geterr		; ooops
getchan MOVE.L	$30(A6),A0	; A0=Dbut table canaux Basic
	MULU	#$28,D0 			 ;
	ADD.L	D0,A0		; lment voulu dans la table
	CMP.L	$34(A6),A0	; si suprieur, on est sorti de la
	BGE.S	geterr		; table, donc erreur 'not found'
	MOVE.L	0(A6,A0.L),D0	; ID canal dans D0. Si<0, le canal est
	BLT.S	geterr		; ferm
	MOVE.L	D0,A0		; A0=ID canal
get_ok	MOVEQ	#$0,D0		; signaler 'pas d'erreur'
get_out RTS
geterr	MOVEQ	#-6,D0		; signaler erreur 'not found'
	RTS


	end
