def proc open_and_display_icon (fnname$)
rem version 1.07
local mfile$,chan%,temp1,temp2
  if fnname$=""
    mfile$=file_sel$('BMP to convert?',"",bmpdir$,"bmp")
    if mfile$="":return 		  : rem try to get filename,leave if none
  else
    mfile$=fnname$
  endif
  select on sprite_mode%
    =0: 				: rem mode 16
      if do_spot%
	mysprite=WL_BMP2SPRT16 (mfile$,'',spotx%,spoty%,do_alpha%)  : rem convert into sprite file on ram
      else
	mysprite=WL_BMP2SPRT16 (mfile$,'',do_alpha%)  : rem convert into sprite file on ram
      endif
    =1: 				: rem mode 64
      if do_spot%
	mysprite=WL_BMP2SPRT64 (mfile$,'',spotx%,spoty%,do_alpha%)  : rem convert into sprite file on ram
      else
	mysprite=WL_BMP2SPRT64 (mfile$,'',do_alpha%)  : rem convert into sprite file on ram
      endif
  end select
  if mysprite<0
    mysprite=0:return			: rem error in opening bitmap
  else
    last_opened$=mfile$
  end if
  spspace=peek_w(mysprite+4)		: rem sprite xsize
  temp1=spspace
  select on sprite_mode%
    =0					: rem mode 16
      temp=spspace mod 4
      if temp
	 spspace=spspace+4-temp 	: rem bytes necessary for one line
      endif
    =1
      spspace=spspace*4 		: rem bytes necessary for one line
  end select
  temp2=peek_w(mysprite+6)		: rem sprite y size
  spspace=spspace*temp2 		: rem size of sprite in pixels/byte for mode 16)
  temp1=temp1*temp2			: rem nbr of pixels in sprite
  if peek(mysprite+3)=32
    spspace=spspace+temp1		: rem alpha mask - one byte per pix
  else
    spspace=spspace*2			: rem normal mask same size as colour
  end if
  spspace=spspace+32			: rem + header = total byte size of sprt
  spspace = spspace + is_odd(spspace)	: rem always an even number
  if mfile$<>"":show_sprite
end def open_and_display_icon
:
def proc show_sprite
local temp,x%,y%
  if not mysprite:display_sizes 0,0:return
  x%=peek_w(mysprite+4) 		: rem sprite x & y size, try to make
  y%=peek_w(mysprite+6) 		: rem wdw big enough, if need be
  if x%>xsize%-8 or y%>ysize%-inf2y
    if x%>xsz%-8 or y%>ysz%-inf2y-2
      return				: rem sprite will exceed window size!
    endif
    dr_unst main_defn
    temp=mysprite
    init x%+8,y%+inf2y+2
    mysprite=temp
    IF compiled
rem	 OPEN#1,'con'
      DR_PPOS main_defn,-1,-1,main_lfl%
    ELSE
      DR_PULD main_defn,-1,-1,main_lfl%
    END IF
  endif
  display_sizes x%,y%
  x%=(xsize%-x%-8)div 2 		: rem centre sprite
  if x%<0:x%=0
  y%=(ysize%-y%-inf2y-2) div 2
  if y%<0:y%=0
  WSPRT#con%,x%,y%,mysprite		: rem write sprite
end def show_sprite
:
def proc display_sizes (xs%,ys%)
rem show the sprite's sizes in the two info wdw
rem if no size, show '---'
rem v. 1.01
local x$,y$,figs%
  paper#con%,0				: rem always on black background
  if xs%=0 and ys%=0
     x$='---'
     y$='---'
  else
     x$=xs%
     y$=ys%
  endif
  figs%=len(x$) 			: rem how many figs to display?
  if len(y$)>figs%:figs%=len(y$)
  if figs%>4:figs%=4
  if figs%<3:figs%=3			: rem always 3 or 4
  DR_IWDF#con%,main_defn,4		: rem reset con chan to inf wdw
  wl_draw_led #con%,inkcol,figs%,x$	: rem draw led
  DR_IWDF#con%,main_defn,5
  wl_draw_led #con%,inkcol,figs%,y$
  DR_IWDF#con%,main_defn,3
  if spritepap$(1)=="$"
    WM_PAPER#con%,hex(spritepap$(2 to)) 	     : rem reset sprite wdw pap & clear it
  else
    paper#con%,hex(spritepap$)
  endif
  cls#con%
end def display_sizes
:
