def proc save_sprite
local lp%,mfile$
  lp%=list_select('Save File as',savechoice$,savechoice%,4)
  if lp%=-1:return
  mfile$=file_sel$('Save to where?','',save_dir$)
  if mfile$="":return			: rem no destination
  lp%=do_save% (mfile$,savechoice%,"")	   :
  if lp%
    mfile$="error saving file"&chr$(10)
    if lp%&&1:mfile$=mfile$&"Basic"&chr$(10)
    if lp%&&2:mfile$=mfile$&"Assembler"&chr$(10)
    if lp%&&4:mfile$=mfile$&"Data"
    rep_err 0,mfile$
  endif
end def save_sprite
:
def fn do_save% (mfile$,sflags%,kwrd$)
rem saves into file, sflags% determines as what we save
rem returns error:0 no error, 1 basic file pb,2 assembler,4 sprite data
rem or any combination thereof
rem if no kwrd is given, then the software prompts for one
local lp%,chan%,sugg$,myerr%
  myerr%=0
  if sflags%(2)
     chan%=fop_over(mfile$&"_bin")	: rem save as basic kwd
     if chan%>0
       if kwrd$=""
	 sugg$=""			  : rem now get kwd name
	 rep lp%
	   sugg$=read_string$("Name of Keyword?",sugg$,"Must be 7 letters long!",7)
	   if sugg$="":close#chan%:return : rem leave if no name entered
	   if len(sugg$)=7:exit lp%	  : rem must be 7 chars exactly
	   beep 1000,1000		  : rem ooops!
	 end rep lp%
       else
	 sugg$=kwrd$
       endif
       make_kwd_header chan%,sugg$	: rem make the keyword itself
       sbytes#chan%, mysprite,spspace	: rem and save the sprites
       close#chan%
     else
       myerr%=1
     endif
  end if
  if sflags%(0)
    chan%=fop_over(mfile$&"_asm")	: rem save as assembler
    if chan%>0
      make_sprite_into_assembler mysprite,chan%
      close#chan%
    else
      myerr%=myerr%+2
    endif
  endif
  if sflags%(1)
    chan%=fop_over(mfile$&"_spr")	: rem save as data file
    if chan%>0
       sbytes#chan%, mysprite,spspace
       close#chan%
    else
       myerr%=myerr%+4
    endif
  endif
  return myerr%
end def do_save
:
