	section setup_scr

*	SETUP_SCR [#chan%]

	xdef	SETUP_SCR
	xdef	scr_xsize
	xdef	scr_ysize
	xdef	scr_base
	xdef	scr_llen
	xdef	scr_bytes

	XREF	chan_num



pt_scren equ    $e8    ; long  address of visible SCREeN
pt_scrsz equ    $ec    ; long  SCReen SiZe in bytes
pt_scinc equ    $f0    ; word  SCreen row INCrement (nbr nytes/line)
pt_xscrs equ    $f2    ; word  X SCReen Size in pixels
pt_yscrs equ    $f4    ; word  Y SCReen Size in pixels



setup_scr BSR	chan_num		; get channl ID into A0
	BNE.S	r_out
	MOVEQ	#-1,D3
	MOVEQ	#0,D1
	MOVEQ	#0,D2
	MOVEQ	#$6F,D0		; pretend to set bytes in linkage block
	TRAP	#3
	TST.L	D0
	BNE.S	r_out
	LEA	scr_base,A2
	MOVE.L	pt_scren(A1),(A2)+	; scr_base
	MOVE.L	pt_xscrs(A1),D1
	MOVE.L	D1,(A2)+		; screen x & y sizes
	MOVE.W	pt_scinc(A1),D0
	MOVE.W	D0,(A2)+		; scr_llen (nbr of bytes per line)
	CLR.W	D1
	SWAP	D1
	DIVS.W	D1,D0
	TST.W	D0
	BEQ.S	no_good		; there must be at least 1 byte/pixel!
	MOVE.W	D0,(A2)+		; scr_bytes = nbr of bytes / pixel
	CLR.L	D0
r_out	RTS

no_good	MOVEQ	#-4,D0		; out of range
	RTS

scr_base	DC.L	0		; base address of screen
scr_xsize DC.W	0		; nbr of pixels (X)
scr_ysize DC.W	0		; "   "	 "     Y
scr_llen	DC.W	0		; length of 1 line in bytes
scr_bytes DC.W	0		; nbr of bytes/pixel

	END
