DEFine PROCedure make_sprite_into_assembler (address,chan%)
LOCal counter,lp%,x%,y%,comma%,tab%,lf%,dcw%,dcl%,dcb%
LOCal totloop%,lineloop%,alpha_mask%,temp%,tops%,pad%
rem v. 1.03
  tab%	=1
  comma%=2
  lf%	=4
  dcw%	=8
  dcl%	=16
  dcb%	=32
  tops%=80
  PRINT#chan%,CHR$(9);"section sprite"
  PRINT#chan%,CHR$(9);'xdef mysprite'
  PRINT#chan%
  PRINT#chan%;"mysprite"
  alpha_mask%=peek(address+3)
  send_word address   ,2,tab%+dcw%,chan%: REMark form
  send_word address+2,2,comma%+lf%,chan%: REMark version + ctrl bytes
  send_word address+4, 2,tab%+dcw%;chan%: rem xsize
  FOR lp%=6 TO 10 STEP 2
    send_word address+lp%,2,comma%,chan%: rem ysize,offsets
  END FOR lp%
  PRINT#chan%
  pattern=address+12
  PRINT#chan%,CHR$(9);"dc.l ms_col-*"
  PRINT#chan%,CHR$(9);"dc.l ms_mask-*"
  PRINT#chan%,CHR$(9);"dc.l 0,0,0"\\"x equ -1"\\"ms_col"
  pattern=pattern+PEEK_L(pattern)	: rem start of colour pattern
  mask=address+16
  mask=mask+PEEK_L(mask)
  x%=PEEK_W(address+4):y%=PEEK_W(address+6): REMark x,y sizes
  lp%=peek(address+1)			: rem sprite type
  select on lp%
    =16 				: rem 8 bit mode
      pad%=x% mod 4			: rem in 8 bit mode, sprites are padded to nearest longword
      if pad%:pad%=4-pad%
      FOR totloop%=0 TO y%-1
	tot_len%=0
	send_word pattern,1,dcb%+tab%,chan% : rem first byte
	pattern=pattern+1		: rem point to next col pattern byte
	FOR lineloop%=1 TO x%-1 +pad%
	    IF tot_len%>tops%
	      PRINT#chan%:tot_len%=0	: rem cut up strings if too long
	      send_word pattern,1,dcb%+tab%,chan%
	    ELSE
	      send_word pattern,1,comma%,chan% : rem next byte
	    END IF
	    pattern=pattern+1		: rem next byte in this line
	END FOR lineloop%
	PRINT#chan% ;			: rem start next line now
      END FOR totloop%			: rem end of col pattern
      PRINT#chan%
      PRINT#chan%,"ms_mask"		: rem now treat mask
      if alpha_mask%=32 : pad%=0
      FOR totloop%=0 TO y%-1
	tot_len%=0
	send_word mask,1,dcb%+tab%,chan%: rem here we have an alpha mask
	mask=mask+1			: rem so each pixel = 1 byte
	FOR lineloop%=1 TO x%-1 + pad%
	  IF tot_len%>tops%
	    PRINT#chan%:tot_len%=0	: rem we exceeded line length
	    send_word mask,1,dcb%+tab%,chan%
	  ELSE
	    send_word mask,1,comma%,chan%
	  END IF
	  mask=mask+1
	END FOR lineloop%
	PRINT#chan%
      END FOR totloop%
      if (((x%+pad%)*y%) && 1):print#chan%,,"dc.b 0",,,,"; padding byte"
    =64 				: rem 32 bit mode sprite
      FOR totloop%=0 TO y%-1
	tot_len%=0
	send_word pattern,4,dcl%+tab%,chan% : rem first lw
	pattern=pattern+4		: rem point to next col pattern lw
	FOR lineloop%=1 TO x%-1
	    IF tot_len%>tops%
	      PRINT#chan%:tot_len%=0	: rem cut up strings if too long
	      send_word pattern,4,dcl%+tab%,chan%
	    ELSE
	      send_word pattern,4,comma%,chan% : rem next long word
	    END IF
	    pattern=pattern+4		: rem next long word in this line
	END FOR lineloop%
	PRINT#chan%			: rem start next line now
      END FOR totloop%			: rem end of col pattern
      PRINT#chan%
      PRINT#chan%,"ms_mask"		: rem now treat masm
      if alpha_mask%=32
	FOR totloop%=0 TO y%-1
	  tot_len%=0			: rem this is an  mask: 1 byte/pixel
	  send_word mask,1,dcb%+tab%,chan%
	  mask=mask+1
	  FOR lineloop%=1 TO x%-1
	    IF tot_len%>tops%
	      PRINT#chan%:tot_len%=0
	      send_word mask,1,dcb%+tab%,chan%
	    ELSE
	      send_word mask,1,comma%,chan%
	    END IF
	    mask=mask+1
	  END FOR lineloop%
	  PRINT#chan%
	END FOR totloop%
	if ((x%*y%) && 1):print#chan%,,"dc.b 0",,,,"; padding byte"
      else
	FOR totloop%=0 TO y%-1
	  tot_len%=0
	  send_word mask,4,dcl%+tab%,chan%
	  mask=mask+4
	  FOR lineloop%=1 TO x%-1
	    IF tot_len%>tops%
	      PRINT#chan%:tot_len%=0
	      send_word mask,4,dcl%+tab%,chan%
	    ELSE
	      send_word mask,4,comma%,chan%
	    END IF
	    mask=mask+4
	  END FOR lineloop%
	  PRINT#chan%
	END FOR totloop%
      endif
    = remainder
      print#chan%;"*** this is a strange looking construct ***"
  end select
  PRINT#chan%
  PRINT#chan%,CHR$(9),"end"
END DEFine make_sprite_into_assembler
:
DEFine FuNction do_peek$ (address,size%)
REMark returns as a hex string the value at address
REMark size determines what kind of peek we're doing: 1 =byte, 2=word,4=long
LOCal a,temp%
  temp%=size%*8
  SELect ON size%
    =1: a=PEEK(address): if a=255:a=-1
    =2: a=PEEK_W(address)
    =4: a=PEEK_L(address)
  END SELect
  IF a=-1:RETurn 'x'
  IF a =0:RETurn '0'
  RETurn HEX$(a,temp%)
END DEFine do_peek$
:
DEFine PROCedure send_word (address,size%,ctrl%,chan%)
REMark print a word to the output file
REMark ctrl% is a bitmap of control code
REMark	bit 1 set : print tab before string
REMark 2 print ',' before string 2
REMark 3 print LF after string	 4
REMark 4 print 'dc.w '		 8
REMark 5 print dc.l		 16
REMark 6 print dc.b		 32
LOCal a$
  a$=do_peek$(address,size%)
  IF NOT (a$ INSTR "0-1x"):a$='$'&a$
  tot_len%=tot_len%+LEN(a$)
  IF ctrl%&&1:PRINT#chan%,CHR$(9);:tot_len%=tot_len%+4
  IF ctrl%&&2:PRINT#chan%,',';:tot_len%=tot_len%+1
  IF ctrl%&&8:PRINT#chan%,'dc.w ';:tot_len%=tot_len%+5
  IF ctrl%&&16:PRINT#chan%,'dc.l ';:tot_len%=tot_len%+5
  IF ctrl%&&32:PRINT#chan%,'dc.b ';:tot_len%=tot_len%+5
  PRINT#chan%,a$;
  IF ctrl%&&4:PRINT#chan%
END DEFine send_word
:
